#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void solve() {
    int n, m;
    std::cin >> n >> m;
    vector<int> out(n), in(n);
    vector<vector<int>> to(n), from(n);
    for (int i = 0, u, v; i < m; ++i) {
        std::cin >> u >> v;
        u--; v--;
        out[u]++;
        in[v]++;
        to[u].push_back(v);
        from[v].push_back(u);
    }
    vector<bool> killed(n);
    set<pair<pair<int, int>, int>> greed;
    for (int i = 0; i < n; i++) greed.insert({{out[i], in[i]}, i});
    while (!greed.empty()) {
        pair<pair<int, int>, int> best = *prev(greed.end());
        cout << best.second + 1 << ' ';
        killed[best.second] = 1;
        greed.erase(best);
        for (int x : from[best.second]) {
            if (!killed[x]) {
                greed.erase({{out[x], in[x]}, x});
                out[x]--;
                greed.insert({{out[x], in[x]}, x});
            }
        }
        for (int x : to[best.second]) {
            if (!killed[x]) {
                greed.erase({{out[x], in[x]}, x});
                in[x]--;
                greed.insert({{out[x], in[x]}, x});
            }
        }
    }
}



int main() {
    cin.tie(0)->sync_with_stdio(false);
    int tests = 1; cin >> tests;
    while (tests--) {
        solve();
        cout << '\n';
    }
}