#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;


/**
 * right - true, left - false, returns right
 */
template<typename F>
int bin_search(int left, int right, F cond) {
    while (right - left > 1) {
        int x = (left + right) / 2;
        if (cond(x))
            right = x;
        else
            left = x;
    }
    return right;
}

void solve() {
    int n; cin >> n;
    vector<int> a(n); for (int &x: a) cin >> x;

    int M = *min_element(a.begin(), a.end());

    int ans = 0;
    for (int rem = 0; rem < 3; rem++) {
        int k = bin_search(-1, M / 3 + 1, [&](int k){
            int g = 3 * k + rem;
            if (g > M)
                return true;

            auto F = [&](int x){
                for (int i = 0; i < n; i++) {
                    int dlt = a[i] - g;
                    x = dlt - 2 * x;
                    if (abs(x) >= 1e9) {
                        if (x > 0)
                            x = 1e9;
                        else
                            x = -1e9;
                    }
                }
                return x;
            };

            int x0 = bin_search(-1e9, 1e9, [&](int x){
                int r = F(x);
                return (r == x) || ((r > x) ^ (n & 1));
            });

            return F(x0) != x0;
        }) - 1;
        ans = max(ans, 3 * k + rem);
    }

    cout << ans << '\n';
}

int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
