#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1e5+10;

int n;
vector<int> g[MAXN];
bool used[MAXN];
vector<int> ans;
    
void dfs (int v) {
    used[v] = true;
    for (size_t i=0; i<g[v].size(); ++i) {
        int to = g[v][i];
        if (!used[to])
            dfs (to);
    }
    ans.push_back (v);
}

void topological_sort() {
    for (int i=1; i<=n; ++i)
        used[i] = false;
    ans.clear();
    for (int i=1; i<=n; ++i)
        if (!used[i])
            dfs (i);
    reverse (ans.begin(), ans.end());
}

int main() {
    int t;
    cin >> t;

    for (int i = 0; i < t; i ++) {
        vector <int> v_int_test;
        vector <pair <int, int>> edges;
        int m;
        cin >> n >> m;

        for (int j = 0; j < m; j ++) {
            int u, v;
            cin >> u >> v;

            g[u].push_back(v);
            v_int_test.push_back(u);
            edges.push_back({u, v});
        }

        topological_sort();
        vector <int> pos(n+1, -1);
        for (int j = 0; j < ans.size(); j ++) {
            pos[ans[j]] = j;
        }
        int x = 0;
        for (auto p: edges) {
            int u = p.first, v = p.second;
            if (pos[u] < pos[v])
                x += 1;
        }
        if (x < (m+1)/2)
            reverse(ans.begin(), ans.end());
        for (auto v: ans)
            cout << v << " ";
        cout << endl;

        for (int u: v_int_test) {
            g[u].clear();
        }
    }
}