#include <iostream>
#include <cmath>
#include <vector>
#include <string>

using I64 = long long;
using BYTE = char;
using V2 = std::vector<std::vector<I64>>;
using STR = std::string;

void IO() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
}
//* static constexpr I64 LIM = 2*100000;

I64** InitCircles(I64 n) {
	I64** c = new I64 * [n] {};
	for (I64 i = 0; i < n; i++)
		c[i] = new I64[3]{};
	return c;
}

void DelCircles(I64** c, I64 n) {
	for (I64 i = 0; i < n; i++)
		delete c[i];
	delete c;
}

void GetInput(I64** c, I64 n) {
	for (I64 i = 0; i < n; i++) {
		std::cin >> c[i][0] >> c[i][1] >> c[i][2];
	}
}

I64 ProcessCircles(I64** c, I64 n) {
	I64 out = 0;
	for (I64 i = 0; i < n; i++) {
		for (I64 j = i + 1; j < n; j++) {
			I64 xabs = abs(c[i][0] - c[j][0]);
			I64 yabs = abs(c[i][1] - c[j][1]);
			I64 r1 = c[i][2];
			I64 r2 = c[j][2];

			if (r1 + r2 == sqrt(xabs * xabs + yabs * yabs)) out++;
		}
	}
	return out;
}

int main() {
	IO();
	I64 tests = 0;
	std::cin >> tests;

	for (I64 t = 0; t < tests; t++) {
		I64 out = 0;
		I64 n = 0;
		std::cin >> n;
		//* V2 circles(n);
		I64** circles = InitCircles(n);
		GetInput(circles, n);
		out = ProcessCircles(circles, n);
		std::cout << out << '\n';
		/*
		for (I64 i = 0; i < n; i++) {
			for (I64 j = 0; j < 3; j++) {
				std::cout << circles[i][j] << ' ';
			}
		}
		*/
		DelCircles(circles, n);
	}
	return 0;
}