#include <algorithm>
#include <bitset>
#include <cmath>
#include <vector>
#include <numeric>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iostream>
#include <iterator>
#include <limits>
#include <iomanip>

#define ll long long
#define ull unsigned long long
#define ld long double

#define INF 1000000000000000ll
#define MOD 998244353ll
#define PI 3.1415926535897932384626433832795

using namespace std;
template <class T>
void print_v(vector<T> &v) { cout << "{"; for (auto x : v) cout << x << ","; cout << "\b}"; }

ll gcd(ll a,ll b) { if (b==0) return a; return gcd(b, a%b); }
bool prime(ll a) { if (a==1) return 0; for (int i=2;i<=round(sqrt(a));++i) if (a%i==0) return 0; return 1; }

ll move_pyro(ll d, ll h) {
    if (h <= 0 || d == 0) return 0;
    if (h == 1) return d;

//    if (d == 2) {
//        return 2 + 3 * move_pyro(2, h - 1);
//    } else {
//        return 1 + move_pyro(2, h - 1) + move_pyro(1, h - 1);
//    }

    return ((1ll + move_pyro(1, h - 1) * 3ll) * d) % MOD;
}

ll pyro_to_array(vector<ll> &to, ll pos, ll d = 0) {
    if (d >= to.size()) return 0;
    if (pos == to[d]) return pyro_to_array(to, pos, d + 1);

    if (abs(pos - to[d]) == 2) {
        return (2 + 2 * 2 * move_pyro(1, (ll)to.size() - d - 1) + pyro_to_array(to, pos, d + 1)) % MOD;
    } else {
        ll c = 6 - pos - to[d];
        if (pos == 2) {
            return (1 + move_pyro(1, (ll)to.size() - d - 1) + pyro_to_array(to, c, d + 1)) % MOD;
        } else {
            return (1 + 2 * move_pyro(1, (ll)to.size() - d - 1) + pyro_to_array(to, c, d + 1)) % MOD;
        }
    }
}

ll pyro_transform(vector<ll> &to, vector<ll> &from, ll d = 0) {
    if (d >= to.size()) return 0;

    if (abs(to[d] - from[d]) == 2) {
        return 2 +
            pyro_to_array(to, from[d], d + 1) +
            move_pyro(2, (ll)to.size() - d - 1) +
            pyro_to_array(from, to[d], d + 1);
    } else {
        ll c = 6 - from[d] - to[d];
        return 1 +
            pyro_to_array(to, c, d + 1) +
            pyro_to_array(from, c, d + 1);
    }
}

void solution() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    ll skips = 0;
    while (skips < n && a[skips] == b[skips]) skips++;
    cout << (pyro_transform(a, b, skips) % MOD) << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cout.precision(12);
    fixed(cout);

    ll tt = 1;
    cin >> tt;
    while (tt--) solution();

    return 0;
}
