#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const size_t MAX_N = 100'000 + 10;
const ll MOD = 998'244'353;

vector<ll> h(MAX_N), g(MAX_N), f(MAX_N);

ll process(const vector<int> &x, int end_idx, int tower_id) {
    int max_disk_idx = -1;
    for (int i = end_idx; i >= 0; --i) {
        if (x[i] == tower_id) {
            continue;
        }
        max_disk_idx = i;
        break;
    }
    if (max_disk_idx == -1) {
        return 0ll;
    }
    ll ans = 0;
    if (abs(x[max_disk_idx] - tower_id) == 1) {
        int tower_id_begin = 6 - x[max_disk_idx] - tower_id;
        ans += process(x, max_disk_idx - 1, tower_id_begin);
        ans++;
        if (abs(tower_id_begin - tower_id) == 2) {
            ans += h[max_disk_idx];
        } else {
            ans += (tower_id == 2) ? g[max_disk_idx] : f[max_disk_idx];
        }
        return ans % MOD;
    }
    // abs(x[max_disk_idx] - tower_id) == 2
    ans += process(x, max_disk_idx - 1, tower_id);
    ans++;
    ans += h[max_disk_idx];
    ans++;
    ans += h[max_disk_idx];
    return ans % MOD;
}

int main() {
    int t;
    cin >> t;
    h[1] = 2;
    g[1] = 1;
    f[1] = 1;
    for (size_t i = 2; i < MAX_N; ++i) {
        h[i] = (3ll * h[i - 1] + 2ll) % MOD;
        g[i] = (h[i - 1] + 1ll + g[i - 1]) % MOD;
        f[i] = (f[i - 1] + h[i - 1] + 1) % MOD;
    }
    for (int i = 0; i < t; ++i) {
        int n;
        cin >> n;
        vector<int> x(n), y(n);
        for (int j = 0; j < n; ++j) {
            cin >> x[j];
        }
        for (int j = 0; j < n; ++j) {
            cin >> y[j];
        }
        int max_disk_idx = -1;
        for (int j = n - 1; j >= 0; --j) {
            if (x[j] == y[j]) {
                continue;
            }
            max_disk_idx = j;
            break;
        }
        if (max_disk_idx == -1) {
            cout << 0 << '\n';
            continue;
        }
        ll ans = 0;
        int tower_id_begin = 6 - x[max_disk_idx] - y[max_disk_idx], tower_id_end = 6 - x[max_disk_idx] - y[max_disk_idx];
        if (abs(x[max_disk_idx] - y[max_disk_idx]) == 1) {
            ans += process(x, max_disk_idx - 1, tower_id_begin);
            ans += 1;
            ans += process(y, max_disk_idx - 1, tower_id_end);
        } else {
            tower_id_begin = y[max_disk_idx];
            tower_id_end = x[max_disk_idx];
            ans += process(x, max_disk_idx - 1, tower_id_begin);
            ans++;
            ans += h[max_disk_idx];
            ans++;
            ans += process(y, max_disk_idx - 1, tower_id_end);
        }
        cout << ans % MOD << '\n';
    }
    return 0;
}
