#include<iostream>
#include<iomanip>
#include<string>
#include<vector>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<queue>
#include<deque>
#include<algorithm>
#include<cmath>
#include<cctype>
#include<fstream>
#include<ios>
#include<bitset>
#include<numbers>
#include <random>
#include <set>

using namespace std;
#define sort(a) sort(a.begin(), a.end())
#define reverse(a) reverse(a.begin(), a.end())
#define all(a) a.begin(), a.end()
#define pb push_back
mt19937 rnd(time(nullptr));

typedef long long ll;

#define MODULO 998244353

int next_corner(const set<int>& corners, int corner) {
    if (*corners.rbegin() == corner) {
        corner = *corners.begin();
    } else {
        corner = *next(corners.find(corner));
    }
    return corner;
}

int dist(int prev, int corner, int n) {
    return corner > prev ? corner - prev : n - prev + corner;
}

int walk(int prev, int corner, bool on_edge, map<int, set<int>>& adj, set<pair<int, int>>& edges, const set<int>& corners, int n) {
    int cnt = 0;
    int first = prev;
    while (corner != first) {
        if (!on_edge) {
            prev = corner;
            corner = (*adj[corner].rbegin() + corner) % n;
            edges.erase({prev, corner});
            on_edge = true;
            ++cnt;
        } else if (prev == (*adj[corner].begin() + corner) % n) {
            prev = corner;
            corner = next_corner(corners, corner);
            cnt += dist(prev, corner, n);
            on_edge = false;
        } else {
            int tmp = prev;
            prev = corner;
            corner = (*std::prev(adj[corner].find((tmp + n - corner) % n)) + corner) % n;
            ++cnt;
            edges.erase({prev, corner});
            on_edge = true;
        }
    }
    return cnt;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        set<pair<int, int>> edges;
        int n, m, k;
        cin >> n >> m >> k;
        if (m == 0) {
            vector<ll> dp_first(n + 1), dp(n + 1);
            dp_first[2] = k * (k - 1) % MODULO;
            dp_first[3] = k * (k - 1) % MODULO * (k - 2) % MODULO;
            dp[2] = 1;
            dp[3] = k - 2;
            for (int j = 4; j < n; ++j) {
                dp_first[j] = (dp_first[j - 1] * (k - 2) % MODULO + dp_first[j - 2] * (k - 1) % MODULO) % MODULO;
                dp[j] = (dp[j - 1] * (k - 2) % MODULO + dp[j - 2] * (k - 1) % MODULO) % MODULO;
            }
            cout << dp_first[n] << "\n";
            continue;
        }
        set<int> corners;
        map<int, set<int>> adj;
        multiset<int> polygons;
        for (int j = 0; j < m; ++j) {
            int a, b;
            cin >> a >> b;
            --a;
            --b;
            edges.insert({a, b});
            edges.insert({b, a});
            corners.insert(a);
            corners.insert(b);
            adj[a].insert((b + n - a) % n);
            adj[b].insert((a + n - b) % n);
        }
        for (int corner: corners) {
            int prev = corner;
            corner = next_corner(corners, corner);
            int cnt = dist(prev, corner, n);
            polygons.insert(cnt + walk(prev, corner, false, adj, edges, corners, n));
        }
        while (!edges.empty()) {
            int prev = edges.begin()->first, corner = edges.begin()->second;
            edges.erase(edges.begin());
            polygons.insert(1 + walk(prev, corner, true, adj, edges, corners, n));
        }
        vector<ll> dp_first(n + 1), dp(n + 1);
        dp_first[2] = k * (k - 1) % MODULO;
        dp_first[3] = k * (k - 1) % MODULO * (k - 2) % MODULO;
        dp[2] = 1;
        dp[3] = k - 2;
        for (int j = 4; j < n; ++j) {
            dp_first[j] = (dp_first[j - 1] * (k - 2) % MODULO + dp_first[j - 2] * (k - 1) % MODULO) % MODULO;
            dp[j] = (dp[j - 1] * (k - 2) % MODULO + dp[j - 2] * (k - 1) % MODULO) % MODULO;
        }
        int result = 1;
        bool first = true;
        for (int j : polygons) {
            if (first) {
                result = (result * dp_first[j]) % MODULO;
            } else {
                result = (result * dp[j]) % MODULO;
            }
            first = false;
        }
        cout << result << "\n";
    }
}
