// ConsoleApplication2.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <time.h>
#include <map>

#define int long long

using namespace std;

int fromTime(string& a)
{
	return (a[0] - '0') * 60 + (a[2] - '0') * 10 + a[3] - '0' - 420;
}

class Pref
{
private:
	vector<int> p;
public:
	Pref(vector<int>& v)
	{
		p.resize(v.size() + 1);
		for (int i = 0; i < v.size(); i++)
			p[i + 1] = v[i] + p[i];
	}
	int get(int l, int r)
	{
		return p[r] - p[l];
	}
};

struct Point
{
	int x, y;
};

int sqr(int num)
{
	return num * num;
}

int sdist(const Point& a, const Point& b)
{
	return sqr(a.x - b.x) + sqr(a.y - b.y);
}

struct Circ
{
	Point c;
	int r;
};

bool sorted(vector<int>& v)
{
	for (int i = 0; i < v.size() - 1; i++)
		if (v[i] > v[i + 1])
			return false;
	return true;
}

bool correct(vector<int>& a, vector<int>& b)
{
	vector<pair<int, int>> d(a.size());
	for (int i = 0; i < a.size(); i++)
		d[i] = { b[i], a[i] };
	sort(begin(d), end(d));
	vector<int> c(a.size());
	for (int i = 0; i < a.size(); i++)
		c[i] = d[i].first - d[i].second;
	if (!sorted(c))
		return false;
	map<int, set<int>> m;
	for (int i = 0; i < a.size(); i++)
		m[b[i]].insert(c[i]);
	for (int i = 0; i < a.size(); i++)
		if (m[b[i]].size() > 1)
			return false;
	return true;

}

unsigned randu()
{
	return (rand() << 15) + rand();
}

void shuffle(vector<int>& v)
{
	for (int i = 0; i < v.size(); i++)
		swap(v[i], v[randu() % v.size()]);
}

bool sortedsecond(vector<pair<int, int>>& b)
{
	for (int i = 0; i < b.size() - 1; i++)
		if (b[i].second > b[i + 1].second)
			return false;
	return true;
}

void solve()
{
	int size;
	cin >> size;
	vector<pair<int, int>> v(size);
	for (auto& i : v)
		cin >> i.first;
	for (auto& i : v)
		cin >> i.second;
	sort(begin(v), end(v));
	if (!sortedsecond(v))
	{
		cout << -1 << '\n';
		return;
	}
	int add = 0;
	for (int i = 0; i < size; i++)
	{
		if (v[i].first + add > v[i].second)
		{
			cout << -1 << '\n';
			return;
		}
		add = max(add, v[i].second - v[i].first);
	}
	cout << add << '\n';
}

signed main()
{
	srand(time(0));
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int t;
	cin >> t;
	while (t--)
		solve();
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
