#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void dfs_topsort(int v, vector<vector<int>> &g, vector<bool> &used, vector<int> &order) {
    used[v] = true;
    for (auto to: g[v])
        if (!used[to])
            dfs_topsort(to, g, used, order);
    order.pb(v);
}

void dfs_comp(int v, vector<vector<int>> &g, vector<int> &comp, vector<int> &comp_vec, int comp_number) {
    comp[v] = comp_number;
    comp_vec.pb(v);
    for (auto to: g[v])
        if (comp[to] == -1) {
            dfs_comp(to, g, comp, comp_vec, comp_number);
        }
}

bool check(vector<int> &comp_vec, vector<int> &comp, vector<vector<int>> &g, int comp_num) {
    map<int, int> v_to_id;
    for (int i = 0; i < comp_vec.size(); i++) {
        v_to_id[comp_vec[i]] = i;
    }
    int cnt = 0;
    for (int v = 0; v < g.size(); v++) {
        for (auto to: g[v]) {
            if (comp[v] == comp[to] && comp[v] == comp_num) {
                cnt += v_to_id[v] < v_to_id[to];
            }
        }
    }
    return cnt >= comp_vec.size();
}

vector<int> solve(int n, int m, vector<vector<int>> g) {
//    for (int i = 0; i < m; i++) {
//        int a, b;
//        cin >> a >> b;
//        g[--a].pb(--b);
//        revg[b].pb(a);
//    }
    vector<bool> used(n, false);
    vector<int> order;
    for (int v = 0; v < n; v++) {
        if (!used[v]) {
            dfs_topsort(v, g, used, order);
        }
    }
    map<int, int> v_to_id;
    for (int i = 0; i < n; i++) v_to_id[order[i]] = i;
    int cnt = 0;
    for (int v = 0; v < n; v++) {
        for (auto to: g[v]) {
            if (v_to_id[v] < v_to_id[to]) {
                cnt++;
            }
        }
    }
    if (cnt < (m + 1) / 2) {
        reverse(all(order));
    }
//    for (auto x: order) cout << x + 1 << " ";
//    cout << "\n";
    return order;
}

void sol() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[--a].pb(--b);
    }
    vector<bool> used(n, false);
    vector<int> order;
    for (int v = 0; v < n; v++) {
        if (!used[v]) {
            dfs_topsort(v, g, used, order);
        }
    }
    map<int, int> v_to_id;
    for (int i = 0; i < n; i++) v_to_id[order[i]] = i;
    int cnt = 0;
    for (int v = 0; v < n; v++) {
        for (auto to: g[v]) {
            if (v_to_id[v] < v_to_id[to]) {
                cnt++;
            }
        }
    }
    if (cnt < (m + 1) / 2) {
        reverse(all(order));
    }
    for (auto x: order) cout << x + 1 << " ";
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

//    {
//        mt19937 rnd(9);
//        for (int i = 0; i < 10000; i++) {
//            int n = rnd() % 100 + 3;
//            int m = rnd() % ((n - 1) * (n - 2)) + 1;
//            vector<vector<int>> g(n);
//            set<pi> st;
//            for (int i = 0; i < m; i++) {
//                int a = rnd() % n;
//                int b = rnd() % n;
//                int tries = 0;
//                while (b == a || st.count({a, b})) {
//                    if (tries > 100) {
//                        a = rnd() % n;
//                    }
//                    tries++;
//                    b = rnd() % n;
//                }
//                st.insert({a, b});
//                g[a].pb(b);
//            }
//            vector<int> res = solve(n, m, g);
//            int cnt = 0;
//            for (int v = 0; v < n; v++)
//                for (auto to: g[v]) {
//                    bool ok = false;
//                    for (auto x: res) {
//                        if (x == v) {
//                            ok = true;
//                            break;
//                        } else if (x == to) {
//                            break;
//                        }
//                    }
//                    cnt += ok;
//                }
//            if (cnt < (m + 1) / 2) {
//                cout << "Wrong!\n";
//                cout << n << " " << m << "\n";
//                for (int i = 0; i < n; i++) {
//                    for (auto to: g[i]) {
//                        cout << i << " " << to << "\n";
//                    }
//                }
//                for (auto x: res) cout << x << " ";
//                cout << "\n";
//                break;
//            }
//        }
//    }

//
    int t = 1;
    cin >> t;
    while (t--) {
//        int n, m;
//        cin >> n >> m;
        sol();
    }
    return 0;
}