#include <algorithm>
#include <cassert>
#include <iostream>
#include <map>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)(c).size()

const int MOD = 998244353;

int sum(int x, int y) {
  return x + y < MOD ? x + y : x + y - MOD;
}

int mul(int x, int y) {
  return x * 1LL * y % MOD;
}

int qp(int x, int k) {
  int res = 1;
  while (k) {
    if (k & 1) {
      res = mul(res, x);
    }
    x = mul(x, x);
    k >>= 1;
  }
  return res;
}

int n, m, k;
set<int> vs;
map<int, set<int>> g;

int f(int l, int r) {
  if (r - l == 1) {
    int res = 1;
    cout << l << ' ' << r << ' ' << res << '\n';
    return res;
  } else if (r - l == 2) {
    int res = k - 2;
    cout << l << ' ' << r << ' ' << res << '\n';
    return res;
  }
  vector<pair<int, bool>> p;
  p.push_back({l, false});
  int i = l;
  while (p.back().first != r) {
    auto elem = g[i].lower_bound(r + (i != l));
    if (elem != g[i].begin() && *(--elem) > i) {
      i = *elem;
      p.push_back({i, true});
    } else {
      elem = vs.upper_bound(i);
      p.push_back({*elem, *elem - i == 1});
      i = *elem;
    }
  }
  if (SZ(p) == 2) {
    int res = mul(k - 2, qp(k - 1, r - l + 1 - 3));
    cout << l << ' ' << r << ' ' << res << '\n';
    return res;
  }
  int res = 1;
  for (int i = 0; i < SZ(p) - 1; ++i) {
    int nh = p[i + 1].second;
    if (i + 1 == SZ(p) - 2 && p.back().second) {
      ++nh;
    }
    if (i != SZ(p) - 2) {
      res = mul(res, k - nh);
    }
    res = mul(res, f(p[i].first, p[i + 1].first));
  }
  cout << l << ' ' << r << ' ' << res << '\n';
  return res;
}

void clear_all() {
  vs.clear();
  g.clear();
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int t;
  cin >> t;
  while (t--) {
    cin >> n >> m >> k;
    for (int i = 0; i < m; ++i) {
      int v, u;
      cin >> v >> u;
      vs.insert(v);
      vs.insert(u);
      g[v].insert(u);
      g[u].insert(v);
    }
    vs.insert(1);
    vs.insert(n);
    g[1].insert(n);
    g[n].insert(1);
    cout << mul(mul(k, k - 1), f(1, n)) << '\n';
    clear_all();
    cout << "====\n";
  }
  return 0;
}