#include <algorithm>
#include <cassert>
#include <iostream>
#include <map>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)(c).size()

const int N = 2e5 + 7;

int n;
int a[N], b[N];

void rotate() {
  int mem = a[0];
  for (int i = 0; i < n - 1; ++i) {
    a[i] = a[i + 1];
  }
  a[n - 1] = mem;
}

bool ok(int x) {
  for (int i = 0; i < n; ++i) {
    b[i] = a[i];
  }
  for (int i = 0; i < n - 1; ++i) {
    if (b[i] < x) {
      return false;
    }
    b[i + 1] = max(0, b[i + 1] - 2 * (b[i] - x));
    b[i] = x;
  }
  return b[n - 1] == x;
}

// int f() {
//   const int INF = 1e9 + 7;
//   int left = 0, right = INF;
//   while (right - left > 1) {
//     int mid = left + right >> 1;
//     (ok(mid) ? left : right) = mid;
//   }
//   ok(left);
//   if (b[n - 1] != left) {
//     return 0;
//   }
//   return left;
// }

const int MOD = 1e9 + 7;

int sum(int x, int y) {
  return x + y < MOD ? x + y : x + y - MOD;
}

int dif(int x, int y) {
  return x - y < 0 ? x - y + MOD : x - y;
}

int mul(int x, int y) {
  return x * 1LL * y % MOD;
}

int qp(int x, int k) {
  int res = 1;
  while (k) {
    if (k & 1) {
      res = mul(res, x);
    }
    x = mul(x, x);
    k >>= 1;
  }
  return res;
}

int inv(int x) {
  return qp(x, MOD - 2);
}

int dv(int x, int y) {
  return mul(x, inv(y));
}

int f() {
  int s = 0, p = 1, c = 0, mx = 0;
  for (int i = n - 1; i >= 0; --i) {
    s = sum(s, mul(p, a[i]));
    if (i == n - 2) {
      c = 2;
    } else {
      c = mul(MOD - 2, dif(c, 1));
    }
    p = MOD - mul(2, p);
    mx = max(mx, a[i]);
  }
  int x = dv(s, dif(1, c));
  return !ok(x) ? 0 : x;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int t;
  cin >> t;
  while (t--) {
    cin >> n;
    for (int i = 0; i < n; ++i) {
      cin >> a[i];
    }
    int res = 0;
    for (int i = 0; i < n; ++i) {
      res = max(res, f());
      rotate();
    }
    cout << res << '\n';
  }
  return 0;
}