#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>

using namespace std;

#define int long long
const int modm = 998244353;


int fst(int a, int b) {
    if (b == 0) return 1;
    auto f = fst(a, b / 2);
    f *= f;
    f %= modm;
    if (b & 1) return (a * f) % modm;
    return f;
}

int solve_full_left_right(int n) {
    return (fst(3, n) + modm - 1) % modm;
}

int solve_left(int n, vector<int>& v, int up) {
    if (up == 0) return 0;
    if (v[up] == 1) return solve_left(n, v, up - 1);
    if (v[up] == 3) {
        auto answer = 2LL *  solve_full_left_right(up - 1) + 2 + solve_left(n, v, up - 1);
        return answer % modm;
    }
    if (v[up] == 2) {
        auto answer = 2LL * solve_full_left_right(up - 1) + 1 + solve_left(n, v, up - 1);
        return answer % modm;
    }
}

int solve_right(int n, vector<int> &v, int up) {
    std::vector<int> x(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        x[i] = 4 - v[i];
    }
    return solve_left(n, x, up);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> was(n + 1, 0), need(n + 1, 0);
        for (int i = 1; i <= n; i++) cin >> was[i];
        for (int i = 1; i <= n; i++) cin >> need[i];
        if (was == need) {
            cout << 0 << endl;
            continue;
        }
        else {
            int where = -1;
            for (int i = n; i >= 1; i--) {
                if (need[i] != was[i]) {
                    where = i;
                    break;
                }
            }
            if (need[where] < was[where]) {
                swap(was, need);
            }
            if (was[where] == 1 && need[where] == 2) {
                auto answer = solve_right(n, was, where - 1) + 1 + solve_right(n, need, where -1);
                cout << answer % modm << endl;
            }
            if (was[where] == 1 && need[where] == 3) {
                auto answer = solve_right(n, was, where - 1) + 2 + solve_left(n, need, where -1) +
                        solve_full_left_right(where - 1);
                cout << answer % modm << endl;
            }
            if (was[where] == 2 && need[where] == 3) {
                auto answer = solve_left(n, was, where - 1) + 2 + solve_left(n, need, where -1);
                cout << answer  % modm<< endl;
            }
        }
    }
}