
#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <iomanip>
#include <string>
#include <random>
#include <typeinfo>
#include <map>
#include <set>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <cstddef>
#include <unordered_map>
#include <array>
#include <ranges>

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx2,popcnt,lzcnt,abm,bmi,bmi2")

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define debug(x) cerr << #x << ": " << x << endl
#define debugvec(x) ({cerr << #x << ":\n"; for (const auto& e :x) cerr << '\t' << e << '\n';})
#else
#define debug(x) ;
#define debugvec(x) ;
#endif

using std::cout;
using std::cin;
using std::cerr;
using std::endl;
using std::ostream;
using std::istream;
using std::vector;
using std::pair;
using std::string;
using std::array;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
std::mt19937 rnd(1488);

template<typename T>
istream &operator>>(istream &in, vector<T> &vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        in >> vec[i];
    }
    return in;
}

ostream &operator<<(ostream &out, const vector<bool> &vec) {
    for (bool i: vec) {
        if (i)
            out << '1';
        else
            out << '0';
    }
    return out;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, const pair<T, U> &p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &vec) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: vec)
        out << e << end_char;
    return out;
}

template<typename T, size_t sz>
ostream &operator<<(ostream &out, const array<T, sz> &arr) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: arr)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T &a, const T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool maxi(T &a, const T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

const int mod = 1e9 + 7;

struct int_mod {
    int x;

    int_mod() = default;

    int_mod(int x_) : x(x_) {};
};

int_mod operator+(int_mod a, int_mod b) {
    int r = a.x + b.x;
    if (r < mod) return {r};
    return {r - mod};
}

int_mod &operator*=(int_mod &a, int_mod b) {
    a.x = (a.x * static_cast<ll>(b.x)) % mod;
    return a;
}


int_mod &operator+=(int_mod &a, int_mod b) {
    a.x = (a.x + b.x) % mod;
    return a;
}

int_mod operator*(int_mod a, int_mod b) {
    return {static_cast<int>((1ll * a.x * b.x) % mod)};
}

int_mod operator*(int_mod a, int b) {
    return {static_cast<int>((1ll * a.x * b) % mod)};
}

int_mod operator-(int_mod a, int_mod b) {
    int r = a.x - b.x;
    if (r < 0) return {r + mod};
    return {r};
}

bool operator==(int_mod a, int_mod b) {
    return a.x == b.x;
}

ostream &operator<<(ostream &out, const int_mod &x) {
    out << x.x;
    return out;
}

int_mod power(int_mod a, int n) {
    if (n == 0) {
        return 1;
    }
    int_mod b = power(a, n / 2);
    if (n % 2 == 1) {
        return b * b * a;
    }
    return b * b;
}

int_mod pow_2n;
int_mod shift;
int_mod delim;
int_mod minus2 = mod - 2;
int mn;

bool check(const vector<int> &a, int x) {
    if (x > mn) {
        return false;
    }
    vector<int_mod> b(a.size());
    for (int i = 0; i < a.size(); ++i) {
        b[i] = a[i] - x; // a_i - 2c_i - c_i' = x
        // 2c_i + c_i' = a_i - x
    }
    vector<int_mod> c(a.size());
    int n = a.size();
    c[0] = 0;
    int_mod p2 = 1;
    for (int i = 0; i < a.size(); ++i) {
        c[0] += p2 * b[(0 - i - 1 + n) % n];
        p2 *= minus2;
    }
    int_mod prev = c[0];
    c[0] *= delim;
    for (int k = 1; k < a.size(); ++k) {
        c[k] = prev * minus2 + b[k - 1] * shift;
        prev = c[k];
        c[k] *= delim;
    }
    for (int i = 0; i < n; ++i) {
        if (2 * static_cast<ll>(c[i].x) + c[(i + 1) % n].x != b[i].x) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    mn = *std::min_element(all(a));
    pow_2n = 1;
    for (int i = 1; i <= n; ++i) {
        pow_2n *= minus2;
    }
    shift = 1 - pow_2n;
    delim = power(1 - pow_2n, mod - 2);
//    cout << check(a, 2) << endl;
//    return;
    int ans = 0;
    for (int o = 0; o < 3; ++o) {
        int left = 0; // surely can
        int right = mn / 3 + 1; // surely can't
        while (right - left > 1) {
            int mid = (left + right) / 2;
            if (check(a, mid * 3 + o)) {
                left = mid;
            } else {
                right = mid;
            }
        }
        if (check(a, left * 3 + o)) {
            maxi(ans, left * 3 + o);
        }
    }
    cout << ans;
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef DUDE
    freopen("./../inputf.in", "r", stdin);
    freopen("./../outputf.out", "w", stdout);
#endif

    // stress();

     #define DUDE
    int test = 1;
#ifdef DUDE
    cin >> test;
#endif
    while (test--) {
        solve();
        cout << '\n';
    }
    return 0;
};