
#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <iomanip>
#include <string>
#include <random>
#include <typeinfo>
#include <map>
#include <set>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <cstddef>
#include <unordered_map>
#include <array>
#include <ranges>

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx2,popcnt,lzcnt,abm,bmi,bmi2")

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define debug(x) cerr << #x << ": " << x << endl
#define debugvec(x) ({cerr << #x << ":\n"; for (const auto& e :x) cerr << '\t' << e << '\n';})
#else
#define debug(x) ;
#define debugvec(x) ;
#endif

using std::cout;
using std::cin;
using std::cerr;
using std::endl;
using std::ostream;
using std::istream;
using std::vector;
using std::pair;
using std::string;
using std::array;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
std::mt19937 rnd(1488);

template<typename T>
istream &operator>>(istream &in, vector<T> &vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        in >> vec[i];
    }
    return in;
}

ostream &operator<<(ostream &out, const vector<bool> &vec) {
    for (bool i: vec) {
        if (i)
            out << '1';
        else
            out << '0';
    }
    return out;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, const pair<T, U> &p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &vec) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: vec)
        out << e << end_char;
    return out;
}

template<typename T, size_t sz>
ostream &operator<<(ostream &out, const array<T, sz> &arr) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: arr)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T &a, const T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool maxi(T &a, const T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

const int mod = 998'244'353;

struct int_mod {
    int x;

    int_mod() = default;

    int_mod(int x_) : x(x_) {};
};

int_mod operator+(int_mod a, int_mod b) {
    int r = a.x + b.x;
    if (r < mod) return {r};
    return {r - mod};
}

int_mod &operator*=(int_mod &a, int_mod b) {
    a.x = (a.x * static_cast<ll>(b.x)) % mod;
    return a;
}


int_mod &operator+=(int_mod &a, int_mod b) {
    a.x = (a.x + b.x) % mod;
    return a;
}

int_mod operator*(int_mod a, int_mod b) {
    return {static_cast<int>((1ll * a.x * b.x) % mod)};
}

int_mod operator*(int_mod a, int b) {
    return {static_cast<int>((1ll * a.x * b) % mod)};
}

int_mod operator-(int_mod a, int_mod b) {
    int r = a.x - b.x;
    if (r < 0) return {r + mod};
    return {r};
}

bool operator==(int_mod a, int_mod b) {
    return a.x == b.x;
}

ostream &operator<<(ostream &out, const int_mod &x) {
    out << x.x;
    return out;
}

int_mod power(int_mod a, int n) {
    if (n == 0) {
        return 1;
    }
    int_mod b = power(a, n / 2);
    if (n % 2 == 1) {
        return b * b * a;
    }
    return b * b;
}

int_mod pmv(int k) {


    int_mod bob = power(2, mod - 2);
    return (power(3, k) - 1) * power(2, mod - 2);
}


int get_mx(array<vector<int>, 3> &v, array<int, 3> &k) {
    int mx = -1;
    for (int i = 0; i < 3; ++i) {
        if (k[i] < v[i].size()) {
            if (mx == -1 || v[i][k[i]] > v[mx][k[mx]]) {
                mx = i;
            }
        }
    }
    return mx;
}

int_mod f(array<vector<int>, 3> &v, array<int, 3> &k, int target) {
    int mx = get_mx(v, k);

    if (mx == -1) {
        return 0;
    }
    array<int, 3> nk = k;
    ++nk[mx];
    int sz = 0;
    for (int i = 0; i < 3; ++i) {
        sz += v[i].size() - nk[i];
    }
    if (mx == target) {
        return f(v, nk, target);
    } else if (abs(mx - target) == 1) {
        if (target == 1) {
            return f(v, nk, 2 - mx) + 1 + pmv(sz);
        } else {
            return f(v, nk, 2 - target) + 1 + 2 * pmv(sz);
        }
    } else {
        return f(v, nk, target) + 2 + 4 * pmv(sz);
    }
}

void solve() {
    int n;
    cin >> n;
    array<vector<int>, 3> v;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        v[x - 1].push_back(i);
    }
    array<vector<int>, 3> u;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        u[x - 1].push_back(i);
    }
    for (int i = 0; i < 3; ++i) {
        std::ranges::reverse(v[i]);
        std::ranges::reverse(u[i]);
    }
    //cerr << v[0] << "|" << v[1] << "|" << v[2] << endl;
    //cerr << u[0] << "|" << u[1] << "|" << u[2] << endl;

    array<int, 3> k = {0, 0, 0};
    int sz = n;
    int mx = -1, target = -1;
    do {
        mx = get_mx(v, k);
        target = get_mx(u, k);
        if (mx != target) {
            break;
        }
        ++k[mx];
        --sz;
    } while (mx != -1);
    //debug(mx);
    //debug(target);

    int_mod ans = 0;
    if (mx != -1) {
        --sz;
        auto vk = k, uk = k;
        ++vk[mx];
        ++uk[target];
        if (abs(mx - target) == 1) {
            if (target == 1) {
                //cerr << f(u, uk, 2 - mx) << endl;
                ans = f(v, vk, 2 - mx) + 1 + f(u, uk, 2 - mx);
            } else {
                ans = f(v, vk, 2 - target) + 1 + f(u, uk, 2 - target);
            }
        } else {
            ans = f(v, vk, target) + 2 + 2 * pmv(sz) + f(u, uk, mx);
        }
    }
    cout << ans << endl;


    for (int i = 0; i < 3; ++i) {
        v[i].clear();
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef DUDE
    freopen("./../inputf.in", "r", stdin);
    freopen("./../outputf.out", "w", stdout);
#endif

    // stress();

#define DUDE
    int test = 1;
#ifdef DUDE
    cin >> test;
#endif
    while (test--) {
        solve();
//        cout << '\n';
    }
    return 0;
};