#include <bits/stdc++.h>

#define int long long
using namespace std;


const int MOD = 1e9+7;


int add(int x, int y) {
    x += y;
    if (x >= MOD) return x - MOD;
    return x;
}
int sub(int x, int y) {
    x -= y;
    if (x < 0) return x + MOD;
    return x;
}
int mult(int x, int y) {
    return (x * y) % MOD;
}
int binPow(int x, int p) {
    if (p == 0) return 1;
    if (p == 2 || (p & 1)) return mult(x, binPow(x, p - 1));
    return binPow(binPow(x, p / 2), 2);
}
int modRev(int x) {
    return binPow(x, MOD - 2);
}
bool check(int x, const vector<int>& b) {
    int n = b.size();
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        a[i] = b[i] - x;
        if (a[i] < 0){
            return false;
        }
    }
    int sum = 0;
    int multiplier = MOD - 2;
    int coef = 1;
    for (int i = 0; i < n; i++){
        sum = add(sum, mult(a[n-1-i], coef));
        coef = mult(coef, multiplier);
    }
    int x_1 = mult(sum, modRev(sub(1, coef)));
    int cur_x = x_1;
    for (int i = 0; i < n-1; i++){
        cur_x = a[i] - 2 * cur_x;
        if (cur_x < 0){
            return false;
        }
    }
    return 2 * cur_x + x_1 == a[n-1];
}

void solve() {
    int n; cin >> n;
    vector<int> a(n); for (auto &x : a) cin >> x;
    // мб тут сделать границу R равной минимальному
    int best = 0;
    for (int ost = 0; ost <= 2; ++ost) {
        int L = -1, R = 1e9;
        while (R - L > 1) {
            int m = (L + R) / 2;
            if (check(m * 3 + ost, a)) {
                L = m;
            } else {
                R = m;
            }
        }
        if (L != -1) {
            best = max(best, 3 * L + ost);
        }
    }
    cout << best << '\n';
}

signed main() {

//   cout << check(2, { 9,9,6,8}) << '\n';
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}
